## x265 2.9

=== source/CMakeLists.txt ===
# vim: syntax=cmake
if(NOT CMAKE_BUILD_TYPE)
    # default to Release build for GCC builds
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()
message(STATUS "cmake version ${CMAKE_VERSION}")
if(POLICY CMP0025)
    cmake_policy(SET CMP0025 OLD) # report Apple's Clang as just Clang
endif()
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # MACOSX_RPATH
endif()
if(POLICY CMP0054)
    cmake_policy(SET CMP0054 OLD) # Only interpret if() arguments as variables or keywords when unquoted
endif()

project (x265)
cmake_minimum_required (VERSION 2.8.8) # OBJECT libraries require 2.8.8
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCXXCompilerFlag)

option(FPROFILE_GENERATE "Compile executable to generate usage data" OFF)
option(FPROFILE_USE "Compile executable using generated usage data" OFF)
option(NATIVE_BUILD "Target the build CPU" OFF)
option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
# X265_BUILD must be incremented each time the public API is changed
set(X265_BUILD 165)
configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
               "${PROJECT_BINARY_DIR}/x265.def")
configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
               "${PROJECT_BINARY_DIR}/x265_config.h")

SET(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

# System architecture detection
string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" SYSPROC)
set(X86_ALIASES x86 i386 i686 x86_64 amd64)
set(ARM_ALIASES armv6l armv7l)
list(FIND X86_ALIASES "${SYSPROC}" X86MATCH)
list(FIND ARM_ALIASES "${SYSPROC}" ARMMATCH)
set(POWER_ALIASES ppc64 ppc64le)
list(FIND POWER_ALIASES "${SYSPROC}" POWERMATCH)
if("${SYSPROC}" STREQUAL "" OR X86MATCH GREATER "-1")
    set(X86 1)
    add_definitions(-DX265_ARCH_X86=1)
    if(CMAKE_CXX_FLAGS STREQUAL "-m32")
        message(STATUS "Detected x86 target processor")
    elseif("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
        set(X64 1)
        add_definitions(-DX86_64=1)
        message(STATUS "Detected x86_64 target processor")
    endif()
elseif(POWERMATCH GREATER "-1")
    message(STATUS "Detected POWER target processor")
    set(POWER 1)
    add_definitions(-DX265_ARCH_POWER=1)
    if("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
        set(PPC64 1)
        add_definitions(-DPPC64=1)
        message(STATUS "Detected POWER PPC64 target processor")
    endif()
elseif(ARMMATCH GREATER "-1")
    if(CROSS_COMPILE_ARM)
        message(STATUS "Cross compiling for ARM arch")
    else()
        set(CROSS_COMPILE_ARM 0)
    endif()
    message(STATUS "Detected ARM target processor")
    set(ARM 1)
    add_definitions(-DX265_ARCH_ARM=1 -DHAVE_ARMV6=1)
else()
    message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
    message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
endif()

if(UNIX)
    list(APPEND PLATFORM_LIBS pthread)
    find_library(LIBRT rt)
    if(LIBRT)
        list(APPEND PLATFORM_LIBS rt)
    endif()
    mark_as_advanced(LIBRT)
    find_library(LIBDL dl)
    if(LIBDL)
        list(APPEND PLATFORM_LIBS dl)
    endif()
    option(ENABLE_LIBNUMA "Enable libnuma usage (Linux only)" ON)
    if(ENABLE_LIBNUMA)
        find_package(Numa)
        if(NUMA_FOUND)
            link_directories(${NUMA_LIBRARY_DIR})
            list(APPEND CMAKE_REQUIRED_LIBRARIES numa)
            check_symbol_exists(numa_node_of_cpu numa.h NUMA_V2)
            if(NUMA_V2)
                add_definitions(-DHAVE_LIBNUMA)
                message(STATUS "libnuma found, building with support for NUMA nodes")
                list(APPEND PLATFORM_LIBS numa)
                include_directories(${NUMA_INCLUDE_DIR})
            endif()
        endif()
        mark_as_advanced(NUMA_FOUND)
    endif(ENABLE_LIBNUMA)
    option(NO_ATOMICS "Use a slow mutex to replace atomics" OFF)
    if(NO_ATOMICS)
        add_definitions(-DNO_ATOMICS=1)
    endif(NO_ATOMICS)
    find_library(VMAF vmaf)
    option(ENABLE_LIBVMAF "Enable VMAF" OFF)
    if(ENABLE_LIBVMAF)
        add_definitions(-DENABLE_LIBVMAF)
    endif()
endif(UNIX)

if(X64 AND NOT WIN32)
    option(ENABLE_PIC "Enable Position Independent Code" ON)
else()
    option(ENABLE_PIC "Enable Position Independent Code" OFF)
endif(X64 AND NOT WIN32)

# Compiler detection
if(CMAKE_GENERATOR STREQUAL "Xcode")
  set(XCODE 1)
endif()
if(APPLE)
  add_definitions(-DMACOS=1)
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CLANG 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    set(INTEL_CXX 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    set(GCC 1)
endif()

if(INTEL_CXX AND WIN32)
    # treat icl roughly like MSVC
    set(MSVC 1)
endif()
if(MSVC)
    if(STATIC_LINK_CRT)
        set(CompilerFlags CMAKE_CXX_FLAGS_RELEASE CMAKE_C_FLAGS_RELEASE)
        foreach(CompilerFlag ${CompilerFlags})
            string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()
    endif(STATIC_LINK_CRT)
    add_definitions(/W4)  # Full warnings
    add_definitions(/Ob2) # always inline
    add_definitions(/MP)  # multithreaded build

    # disable Microsofts suggestions for proprietary secure APIs
    add_definitions(/D_CRT_SECURE_NO_WARNINGS)

    check_include_files(stdint.h HAVE_STDINT_H)
    if(NOT HAVE_STDINT_H)
        include_directories(compat/msvc)
    endif()
endif(MSVC)

check_include_files(inttypes.h HAVE_INT_TYPES_H)
if(HAVE_INT_TYPES_H)
    add_definitions(-DHAVE_INT_TYPES_H=1)
endif()

if(INTEL_CXX AND UNIX)
    set(GCC 1) # treat icpc roughly like gcc
elseif(CLANG)
    set(GCC 1) # treat clang roughly like gcc
elseif(CMAKE_COMPILER_IS_GNUCXX)
    set(GCC 1)
endif()

if(CC STREQUAL "xlc")
    message(STATUS "Use XLC compiler")
    set(XLC 1)
    set(GCC 0)
    #set(CMAKE_C_COMPILER "/usr/bin/xlc")
    #set(CMAKE_CXX_COMPILER "/usr/bin/xlc++")
    add_definitions(-D__XLC__=1)
    add_definitions(-O3 -qstrict -qhot -qaltivec)
    add_definitions(-qinline=level=10 -qpath=IL:/data/video_files/latest.tpo/)
endif()
# this option is to enable the inclusion of dynamic HDR10 library to the libx265 compilation
option(ENABLE_HDR10_PLUS "Enable dynamic HDR10 compilation" OFF)
if(MSVC AND (MSVC_VERSION LESS 1800) AND ENABLE_HDR10_PLUS)
    message(FATAL_ERROR "MSVC version 12.0 or above required to support hdr10plus")
endif()
if(WIN32 AND (MSVC_VERSION GREATER 1800))
    if(CMAKE_VERSION VERSION_LESS 3.7)
        message(FATAL_ERROR "cmake version not compatible for VS 2017. Update the cmake to versions 3.7 or above")
    endif()
endif()
if(GCC)
    add_definitions(-Wall -Wextra -Wshadow)
    add_definitions(-D__STDC_LIMIT_MACROS=1)
    if(ENABLE_HDR10_PLUS)
        if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8")
            message(FATAL_ERROR "gcc version above 4.8 required to support hdr10plus")
        endif()
        add_definitions(-std=gnu++11)
    else()
        add_definitions(-std=gnu++98)
    endif()
    if(ENABLE_PIC)
         add_definitions(-fPIC)
    endif(ENABLE_PIC)
    if(NATIVE_BUILD)
        if(INTEL_CXX)
            add_definitions(-xhost)
        else()
            add_definitions(-march=native)
        endif()
    elseif(X86 AND NOT X64)
        string(FIND "${CMAKE_CXX_FLAGS}" "-march" marchPos)
        if(marchPos LESS "0")
            add_definitions(-march=i686)
            if(WIN32 AND NOT INTEL_CXX AND NOT CLANG AND
               CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.0 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
                add_definitions(-mpreferred-stack-boundary=2)
            endif()
        endif()
    endif()
    if(ARM AND CROSS_COMPILE_ARM)
        set(ARM_ARGS -march=armv6 -mfloat-abi=soft -mfpu=vfp -marm -fPIC)
    elseif(ARM)
        find_package(Neon)
        if(CPU_HAS_NEON)
            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=neon -marm -fPIC)
            add_definitions(-DHAVE_NEON)
        else()
            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=vfp -marm)
        endif()
    endif()
    add_definitions(${ARM_ARGS})
    if(FPROFILE_GENERATE)
        if(INTEL_CXX)
            add_definitions(-prof-gen -prof-dir="${CMAKE_CURRENT_BINARY_DIR}")
            list(APPEND LINKER_OPTIONS "-prof-gen")
        else()
            check_cxx_compiler_flag(-fprofile-generate CC_HAS_PROFILE_GENERATE)
            if(CC_HAS_PROFILE_GENERATE)
                add_definitions(-fprofile-generate)
                list(APPEND LINKER_OPTIONS "-fprofile-generate")
            endif(CC_HAS_PROFILE_GENERATE)
        endif(INTEL_CXX)
    endif(FPROFILE_GENERATE)
    if(FPROFILE_USE)
        if(INTEL_CXX)
            add_definitions(-prof-use -prof-dir="${CMAKE_CURRENT_BINARY_DIR}")
            list(APPEND LINKER_OPTIONS "-prof-use")
        else()
            check_cxx_compiler_flag(-fprofile-use CC_HAS_PROFILE_USE)
            check_cxx_compiler_flag(-fprofile-correction CC_HAS_PROFILE_CORRECTION)
            check_cxx_compiler_flag(-Wno-error=coverage-mismatch CC_HAS_COVMISMATCH)
            if(CC_HAS_PROFILE_USE)
                add_definitions(-fprofile-use)
                list(APPEND LINKER_OPTIONS "-fprofile-use")
            endif(CC_HAS_PROFILE_USE)
            if(CC_HAS_PROFILE_CORRECTION)
                # auto-correct corrupted counters (happens a lot with x265)
                add_definitions(-fprofile-correction)
            endif(CC_HAS_PROFILE_CORRECTION)
            if(CC_HAS_COVMISMATCH)
                # ignore coverage mismatches (also happens a lot)
                add_definitions(-Wno-error=coverage-mismatch)
            endif(CC_HAS_COVMISMATCH)
        endif(INTEL_CXX)
    endif(FPROFILE_USE)
    if(STATIC_LINK_CRT)
        add_definitions(-static)
        list(APPEND LINKER_OPTIONS "-static-libgcc")
    endif(STATIC_LINK_CRT)
    check_cxx_compiler_flag(-Wno-strict-overflow CC_HAS_NO_STRICT_OVERFLOW)
    check_cxx_compiler_flag(-Wno-narrowing CC_HAS_NO_NARROWING) 
    check_cxx_compiler_flag(-Wno-array-bounds CC_HAS_NO_ARRAY_BOUNDS) 
    if (CC_HAS_NO_ARRAY_BOUNDS)
        add_definitions(-Wno-array-bounds) # these are unhelpful
    endif()
    check_cxx_compiler_flag(-ffast-math CC_HAS_FAST_MATH) 
    if (CC_HAS_FAST_MATH)
        add_definitions(-ffast-math)
    endif()
    check_cxx_compiler_flag(-mstackrealign CC_HAS_STACK_REALIGN) 
    if (CC_HAS_STACK_REALIGN)
        add_definitions(-mstackrealign)
    endif()
    # Disable exceptions. Reduce executable size, increase compability.
    check_cxx_compiler_flag(-fno-exceptions CC_HAS_FNO_EXCEPTIONS_FLAG)
    if(CC_HAS_FNO_EXCEPTIONS_FLAG)
        add_definitions(-fno-exceptions)
    endif()
    set(FSANITIZE "" CACHE STRING "-fsanitize options for GCC/clang")
    if(FSANITIZE)
        add_definitions(-fsanitize=${FSANITIZE})
        # clang and gcc need the sanitize options to be passed at link
        # time so the appropriate ASAN/TSAN runtime libraries can be
        # linked.
        list(APPEND LINKER_OPTIONS "-fsanitize=${FSANITIZE}")
    endif()
    option(ENABLE_AGGRESSIVE_CHECKS "Enable stack protection and -ftrapv" OFF)
    if(ENABLE_AGGRESSIVE_CHECKS)
        # use with care, -ftrapv can cause testbench SIGILL exceptions
        # since it is testing corner cases of signed integer math
        add_definitions(-DUSING_FTRAPV=1)
        check_cxx_compiler_flag(-fsanitize=undefined-trap CC_HAS_CATCH_UNDEFINED) # clang
        check_cxx_compiler_flag(-ftrapv CC_HAS_FTRAPV)                            # gcc
        check_cxx_compiler_flag(-fstack-protector-all CC_HAS_STACK_PROTECT)       # gcc
        if(CC_HAS_FTRAPV)
            add_definitions(-ftrapv)
        endif()
        if(CC_HAS_CATCH_UNDEFINED)
            add_definitions(-fsanitize=undefined-trap -fsanitize-undefined-trap-on-error)
        endif()

=== debian/changelog ===
x265 (2.9-4) unstable; urgency=medium

  * debian/libx265-165.symbols: Mark CPU detection related symbols as
    optional.
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 25 Jan 2019 09:24:28 +0100

x265 (2.9-3) unstable; urgency=medium

  * debian/patches: Define detect512 on every architecture. (Closes: #910963)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 14 Oct 2018 14:06:00 +0200

x265 (2.9-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 13 Oct 2018 12:55:25 +0200

x265 (2.9-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: 160 -> 165.
  * debian/patches: Drop patches included upstream.
  * debian/libx265-165.symbols:
    - Add missing symbols.
    - Be more specific when marking symbols as optional.
    - Add Build-Depends-Package.
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 09 Oct 2018 23:51:13 +0200

x265 (2.8-4) unstable; urgency=medium

  * debian/rules: Fix generation of combined static libraries. (LP: #1777875)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 24 Jun 2018 13:35:38 +0200

=== debian/control ===
Source: x265
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
 nasm (>= 2.13) [amd64 kfreebsd-amd64]
Build-Depends-Indep:
 python3-sphinx
Standards-Version: 4.3.0
Homepage: http://x265.org
Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/x265

Package: x265
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.265/HEVC video stream encoder
 x265 is a commandline encoder for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 x265 supports the following features:
  * full prediction and transform quad-tree recursion supported
  * adaptive B-frame placement
  * B-frames as references / arbitrary frame order
  * CABAC (context-based adaptive binary arithmetic coding) entropy coding
  * supports all Intra block types
  * supports all Inter P partitions
  * supports all Inter B partitions from 64x64 down to 8x4
  * weighted prediction for P slices
  * multiple reference frames
  * scenecut detection
  * parallel encoding on multiple CPUs

Package: libx265-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libx265-165 (= ${binary:Version})
Suggests:
 libx265-doc
Description: H.265/HEVC video stream encoder (development files)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This is the development package which contains headers and libraries for
 libx265.

Package: libx265-165
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.265/HEVC video stream encoder (shared library)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This package contains the shared library.

Package: libx265-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Description: H.265/HEVC video stream encoder (documentation)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This package contains documentation for the command line encoder and the
 shared library.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
	-L$(CURDIR)/x265-10bit \
	-L$(CURDIR)/x265-12bit
# see #789111
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
# LFS support
export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)

FLAGS  = -DENABLE_PIC=ON
# currently fails to build
# FLAGS += -DENABLE_DYNAMIC_HDR10=ON
FLAGS_OTHERBIT  = -DENABLE_CLI=OFF
FLAGS_OTHERBIT += -DENABLE_SHARED=OFF
FLAGS_OTHERBIT += -DEXPORT_C_API=OFF
FLAGS_OTHERBIT += -DHIGH_BIT_DEPTH=ON

# enable assembly builds on amd64, kfreebsd-amd64
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64))
FLAGS += -DENABLE_ASSEMBLY=ON
else
FLAGS += -DENABLE_ASSEMBLY=OFF
endif

# disable altive on ppc64el if building 10 bit and 12 bit versions
# see https://bitbucket.org/multicoreware/x265/issues/320/fail-to-build-on-power8-le
ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el ppc64))
FLAGS_OTHERBIT += -DENABLE_ALTIVEC=OFF
endif

%:
	dh $@ --buildsystem=cmake \
		--sourcedirectory=source \
		--builddirectory=x265-8bit

override_dh_auto_clean:
	dh_auto_clean --builddirectory=x265-10bit
	dh_auto_clean --builddirectory=x265-12bit
	dh_auto_clean
	rm -rf doc/reST/build

# -arch bits

override_dh_auto_configure-arch:
	dh_auto_configure --builddirectory=x265-10bit -- \
		$(FLAGS) $(FLAGS_OTHERBIT)
	dh_auto_configure --builddirectory=x265-12bit -- \
		$(FLAGS) $(FLAGS_OTHERBIT) \
		-DMAIN12=ON
	dh_auto_configure -- \
		$(FLAGS) $(FLAGS_8BIT) \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH) \
		-DEXTRA_LIB="x265_main10.a;x265_main12.a" \
		-DLINKED_10BIT=ON \
		-DLINKED_12BIT=ON

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=x265-10bit
	dh_auto_build --builddirectory=x265-12bit
	mv x265-10bit/libx265.a x265-10bit/libx265_main10.a
	mv x265-12bit/libx265.a x265-12bit/libx265_main12.a
	dh_auto_build

debian/arscript:
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/' debian/arscript.in > debian/arscript

override_dh_auto_install-arch: debian/arscript
	dh_auto_install
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libx265.a
	ar -M <debian/arscript

# -indep bits

# no configure, test and install for indep
override_dh_auto_configure-indep override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_build-indep:
	$(MAKE) -C doc/reST html

override_dh_installdocs-indep:
	dh_installdocs
	dh_sphinxdoc

override_dh_installchangelogs:
	dh_installchangelogs doc/reST/releasenotes.rst

## x265 3.0

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 165)
+set(X265_BUILD 169)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -200,6 +200,9 @@
 if(GCC)
     add_definitions(-Wall -Wextra -Wshadow)
     add_definitions(-D__STDC_LIMIT_MACROS=1)
+    if(NOT INTEL_CXX AND NOT CLANG AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 8.0)
+        add_definitions(-Wno-class-memaccess)
+    endif()
     if(ENABLE_HDR10_PLUS)
         if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8")
             message(FATAL_ERROR "gcc version above 4.8 required to support hdr10plus")
@@ -315,6 +318,3 @@
         if(CC_HAS_FTRAPV)
             add_definitions(-ftrapv)
         endif()
-        if(CC_HAS_CATCH_UNDEFINED)
-            add_definitions(-fsanitize=undefined-trap -fsanitize-undefined-trap-on-error)
-        endif()

=== debian/changelog ===
x265 (3.0-2) experimental; urgency=medium

  * debian/rules: Disable AltiVec on ppc64 and -mcpu=power8 on ppc64. (Closes:
    #923650)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 03 Mar 2019 22:13:50 +0100

x265 (3.0-1) experimental; urgency=medium

  * New upstream version release
  * SONAME bump: 165 -> 169.
  * debian/: Bump debhelper compat to 12.
  * debian/patches: Drop obsolete patch.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Feb 2019 15:03:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  cmake,
  libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
  nasm (>= 2.13) [amd64 kfreebsd-amd64]
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-165 (= ${binary:Version})
+ libx265-169 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-165
+Package: libx265-169
 Section: libs
 Architecture: any
 Multi-Arch: same

## x265 3.1.1

=== debian/changelog ===
x265 (3.1.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Aug 2019 19:49:09 +0200

x265 (3.1.1-1) experimental; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.0

  [ Sebastian Ramacher ]
  * New upstream release.
  * SONAME bump: 169 -> 176.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 05 Aug 2019 23:24:23 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  nasm (>= 2.13) [amd64 kfreebsd-amd64]
 Build-Depends-Indep:
  python3-sphinx
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: http://x265.org
 Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-169 (= ${binary:Version})
+ libx265-176 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-169
+Package: libx265-176
 Section: libs
 Architecture: any
 Multi-Arch: same

## x265 3.1.2

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 169)
+set(X265_BUILD 176)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"

## x265 3.2

=== debian/changelog ===
x265 (3.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 13 Oct 2019 15:42:37 +0200

x265 (3.2-1) experimental; urgency=medium

  * New upstream release
  * SONAME bump: 176 -> 179
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 30 Sep 2019 20:53:31 +0200

## x265 3.2.1

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 176)
+set(X265_BUILD 179)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"

=== debian/changelog ===
x265 (3.2.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:29:02 +0100

x265 (3.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 08 Dec 2019 10:47:39 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  nasm (>= 2.13) [amd64 kfreebsd-amd64]
 Build-Depends-Indep:
  python3-sphinx
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: http://x265.org
 Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-176 (= ${binary:Version})
+ libx265-179 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-176
+Package: libx265-179
 Section: libs
 Architecture: any
 Multi-Arch: same

## x265 3.3

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 179)
+set(X265_BUILD 188)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"

## x265 3.4

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 188)
+set(X265_BUILD 192)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -40,7 +40,7 @@
 # System architecture detection
 string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" SYSPROC)
 set(X86_ALIASES x86 i386 i686 x86_64 amd64)
-set(ARM_ALIASES armv6l armv7l)
+set(ARM_ALIASES armv6l armv7l aarch64)
 list(FIND X86_ALIASES "${SYSPROC}" X86MATCH)
 list(FIND ARM_ALIASES "${SYSPROC}" ARMMATCH)
 set(POWER_ALIASES ppc64 ppc64le)
@@ -70,9 +70,15 @@
     else()
         set(CROSS_COMPILE_ARM 0)
     endif()
-    message(STATUS "Detected ARM target processor")
     set(ARM 1)
-    add_definitions(-DX265_ARCH_ARM=1 -DHAVE_ARMV6=1)
+    if("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
+        message(STATUS "Detected ARM64 target processor")
+        set(ARM64 1)
+        add_definitions(-DX265_ARCH_ARM=1 -DX265_ARCH_ARM64=1 -DHAVE_ARMV6=0)
+    else()
+        message(STATUS "Detected ARM target processor")
+        add_definitions(-DX265_ARCH_ARM=1 -DX265_ARCH_ARM64=0 -DHAVE_ARMV6=1)
+    endif()
 else()
     message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
     message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
@@ -95,6 +101,8 @@
         if(NUMA_FOUND)
             link_directories(${NUMA_LIBRARY_DIR})
             list(APPEND CMAKE_REQUIRED_LIBRARIES numa)
+            list(APPEND CMAKE_REQUIRED_INCLUDES ${NUMA_INCLUDE_DIR})
+            list(APPEND CMAKE_REQUIRED_LINK_OPTIONS "-L${NUMA_LIBRARY_DIR}")
             check_symbol_exists(numa_node_of_cpu numa.h NUMA_V2)
             if(NUMA_V2)
                 add_definitions(-DHAVE_LIBNUMA)
@@ -231,14 +239,24 @@
         endif()
     endif()
     if(ARM AND CROSS_COMPILE_ARM)
-        set(ARM_ARGS -march=armv6 -mfloat-abi=soft -mfpu=vfp -marm -fPIC)
+        if(ARM64)
+            set(ARM_ARGS -fPIC)
+        else()
+            set(ARM_ARGS -march=armv6 -mfloat-abi=soft -mfpu=vfp -marm -fPIC)
+        endif()
+        message(STATUS "cross compile arm")
     elseif(ARM)
-        find_package(Neon)
-        if(CPU_HAS_NEON)
-            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=neon -marm -fPIC)
+        if(ARM64)
+            set(ARM_ARGS -fPIC)
             add_definitions(-DHAVE_NEON)
         else()
-            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=vfp -marm)
+            find_package(Neon)
+            if(CPU_HAS_NEON)
+                set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=neon -marm -fPIC)
+                add_definitions(-DHAVE_NEON)
+            else()
+                set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=vfp -marm)
+            endif()
         endif()
     endif()
     add_definitions(${ARM_ARGS})
@@ -305,16 +323,3 @@
         # clang and gcc need the sanitize options to be passed at link
         # time so the appropriate ASAN/TSAN runtime libraries can be
         # linked.
-        list(APPEND LINKER_OPTIONS "-fsanitize=${FSANITIZE}")
-    endif()
-    option(ENABLE_AGGRESSIVE_CHECKS "Enable stack protection and -ftrapv" OFF)
-    if(ENABLE_AGGRESSIVE_CHECKS)
-        # use with care, -ftrapv can cause testbench SIGILL exceptions
-        # since it is testing corner cases of signed integer math
-        add_definitions(-DUSING_FTRAPV=1)
-        check_cxx_compiler_flag(-fsanitize=undefined-trap CC_HAS_CATCH_UNDEFINED) # clang
-        check_cxx_compiler_flag(-ftrapv CC_HAS_FTRAPV)                            # gcc
-        check_cxx_compiler_flag(-fstack-protector-all CC_HAS_STACK_PROTECT)       # gcc
-        if(CC_HAS_FTRAPV)
-            add_definitions(-ftrapv)
-        endif()

=== source/encoder/CMakeLists.txt ===
# vim: syntax=cmake

if(GCC)
    add_definitions(-Wno-uninitialized)
    if(CC_HAS_NO_STRICT_OVERFLOW)
        # GCC 4.9.2 gives warnings we know we can ignore in this file
        set_source_files_properties(slicetype.cpp PROPERTIES COMPILE_FLAGS -Wno-strict-overflow)
    endif(CC_HAS_NO_STRICT_OVERFLOW)
endif()
if(MSVC)
   add_definitions(/wd4701) # potentially uninitialized local variable 'foo' used
endif()

if(EXTRA_LIB)
    if(LINKED_8BIT)
        list(APPEND APIFLAGS "-DLINKED_8BIT=1")
    endif(LINKED_8BIT)
    if(LINKED_10BIT)
        list(APPEND APIFLAGS "-DLINKED_10BIT=1")
    endif(LINKED_10BIT)
    if(LINKED_12BIT)
        list(APPEND APIFLAGS "-DLINKED_12BIT=1")
    endif(LINKED_12BIT)
    string(REPLACE ";" " " APIFLAGSTR "${APIFLAGS}")
    set_source_files_properties(api.cpp PROPERTIES COMPILE_FLAGS ${APIFLAGSTR})
endif(EXTRA_LIB)

add_library(encoder OBJECT ../x265.h
    analysis.cpp analysis.h
    search.cpp search.h
    bitcost.cpp bitcost.h rdcost.h
    motion.cpp motion.h
    slicetype.cpp slicetype.h
    frameencoder.cpp frameencoder.h
    framefilter.cpp framefilter.h
    level.cpp level.h
    nal.cpp nal.h
    sei.cpp sei.h
    sao.cpp sao.h
    entropy.cpp entropy.h
    dpb.cpp dpb.h
    ratecontrol.cpp ratecontrol.h
    reference.cpp reference.h
    encoder.cpp encoder.h
    api.cpp
    weightPrediction.cpp svt.h)

=== source/test/CMakeLists.txt ===
# vim: syntax=cmake

check_symbol_exists(__rdtsc "intrin.h" HAVE_RDTSC)
if(HAVE_RDTSC)
    add_definitions(-DHAVE_RDTSC=1)
endif()

# add X86 assembly files
if(X86)
enable_language(ASM_NASM)

if(MSVC_IDE)
    set(NASM_SRC checkasm-a.obj)
    add_custom_command(
        OUTPUT checkasm-a.obj
        COMMAND ${NASM_EXECUTABLE}
        ARGS ${NASM_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/checkasm-a.asm -o checkasm-a.obj
        DEPENDS checkasm-a.asm)
else()
    set(NASM_SRC checkasm-a.asm)
endif()
endif(X86)

# add ARM assembly files
if(ARM OR CROSS_COMPILE_ARM)
    if(NOT ARM64)
        enable_language(ASM)
        set(NASM_SRC checkasm-arm.S)
        add_custom_command(
            OUTPUT checkasm-arm.obj
            COMMAND ${CMAKE_CXX_COMPILER}
            ARGS ${NASM_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/checkasm-arm.S -o checkasm-arm.obj
            DEPENDS checkasm-arm.S)
    endif()
endif(ARM OR CROSS_COMPILE_ARM)

# add PowerPC assembly files
if(POWER)
    set(NASM_SRC)
endif(POWER)

add_executable(TestBench ${NASM_SRC}
    testbench.cpp testharness.h
    pixelharness.cpp pixelharness.h
    mbdstharness.cpp mbdstharness.h
    ipfilterharness.cpp ipfilterharness.h
    intrapredharness.cpp intrapredharness.h)

target_link_libraries(TestBench x265-static ${PLATFORM_LIBS})
if(LINKER_OPTIONS)
    if(EXTRA_LIB)
        list(APPEND LINKER_OPTIONS "-L..")
    endif(EXTRA_LIB)
    string(REPLACE ";" " " LINKER_OPTION_STR "${LINKER_OPTIONS}")
    set_target_properties(TestBench PROPERTIES LINK_FLAGS "${LINKER_OPTION_STR}")
endif()

=== source/profile/vtune/CMakeLists.txt ===
include_directories(${VTUNE_INCLUDE_DIR})
add_library(vtune vtune.h vtune.cpp ../cpuEvents.h)

=== debian/changelog ===
x265 (3.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 12 Jul 2020 18:47:02 +0200

x265 (3.4-1) experimental; urgency=medium

  * New upstream release
  * SONAME bump: 179 -> 192
  * debian/copyright: Bump copyright years
  * debian/control:
    - Bump Standards-Version
    - Bump debhelper compat to 13

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 21 Jun 2020 18:15:38 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
  libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
  nasm (>= 2.13) [amd64 kfreebsd-amd64]
 Build-Depends-Indep:
  python3-sphinx
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://x265.org
 Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-179 (= ${binary:Version})
+ libx265-192 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-179
+Package: libx265-192
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -27,9 +27,13 @@
 FLAGS += -DENABLE_ASSEMBLY=OFF
 endif
 
-# disable altive on ppc64el if building 10 bit and 12 bit versions
+# disable altivec on ppc64 (see #923650)
+ifneq (,$(filter $(DEB_HOST_ARCH),ppc64))
+FLAGS += -DENABLE_ALTIVEC=OFF -DCPU_POWER8=OFF
+endif
+# disable altivec on ppc64el if building 10 bit and 12 bit versions
 # see https://bitbucket.org/multicoreware/x265/issues/320/fail-to-build-on-power8-le
-ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el ppc64))
+ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
 FLAGS_OTHERBIT += -DENABLE_ALTIVEC=OFF
 endif

=== debian/watch ===
version=3
http://ftp.videolan.org/pub/videolan/x265/ \
  x265_(\d.*).tar.gz

## x265 3.5

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 192)
+set(X265_BUILD 199)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"

=== source/common/CMakeLists.txt ===
# vim: syntax=cmake

list(APPEND VFLAGS "-DX265_VERSION=${X265_VERSION}")
if(EXTRA_LIB)
    if(LINKED_8BIT)
        list(APPEND VFLAGS "-DLINKED_8BIT=1")
    endif(LINKED_8BIT)
    if(LINKED_10BIT)
        list(APPEND VFLAGS "-DLINKED_10BIT=1")
    endif(LINKED_10BIT)
    if(LINKED_12BIT)
        list(APPEND VFLAGS "-DLINKED_12BIT=1")
    endif(LINKED_12BIT)
endif(EXTRA_LIB)

if(ENABLE_ASSEMBLY)
    set_source_files_properties(threading.cpp primitives.cpp pixel.cpp PROPERTIES COMPILE_FLAGS -DENABLE_ASSEMBLY=1)
    list(APPEND VFLAGS "-DENABLE_ASSEMBLY=1")
endif(ENABLE_ASSEMBLY)

if(ENABLE_ASSEMBLY AND X86)
    set(SSE3  vec/dct-sse3.cpp)
    set(SSSE3 vec/dct-ssse3.cpp)
    set(SSE41 vec/dct-sse41.cpp)

    if(MSVC)
        set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
        set(WARNDISABLE "/wd4100") # unreferenced formal parameter
        if(INTEL_CXX)
            add_definitions(/Qwd111) # statement is unreachable
            add_definitions(/Qwd128) # loop is unreachable
            add_definitions(/Qwd177) # declared function is unused
            add_definitions(/Qwd185) # dynamic initialization in unreachable code
            add_definitions(/Qwd280) # conditional expression is constant
        endif()
        if(X64)
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE}")
        else()
            # x64 implies SSE4, so only add /arch:SSE2 if building for Win32
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} /arch:SSE2")
        endif()
    endif()
    if(GCC)
        if(CLANG)
            # llvm intrinsic headers cause shadow warnings
            set(WARNDISABLE "-Wno-shadow -Wno-unused-parameter")
        else()
            set(WARNDISABLE "-Wno-unused-parameter")
        endif()
        if(INTEL_CXX OR CLANG OR (NOT CC_VERSION VERSION_LESS 4.3))
            set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
            set_source_files_properties(${SSE3}  PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse3")
            set_source_files_properties(${SSSE3} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -mssse3")
            set_source_files_properties(${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse4.1")
        endif()
    endif()
    set(VEC_PRIMITIVES vec/vec-primitives.cpp ${PRIMITIVES})
    source_group(Intrinsics FILES ${VEC_PRIMITIVES})
    set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h seaintegral.h)
    set(A_SRCS pixel-a.asm const-a.asm cpu-a.asm ssd-a.asm mc-a.asm
               mc-a2.asm pixel-util8.asm blockcopy8.asm
               pixeladd8.asm dct8.asm seaintegral.asm)
    if(HIGH_BIT_DEPTH)
        set(A_SRCS ${A_SRCS} sad16-a.asm intrapred16.asm v4-ipfilter16.asm h4-ipfilter16.asm h-ipfilter16.asm ipfilter16.asm loopfilter.asm)
    else()
        set(A_SRCS ${A_SRCS} sad-a.asm intrapred8.asm intrapred8_allangs.asm v4-ipfilter8.asm h-ipfilter8.asm ipfilter8.asm loopfilter.asm)
    endif()
    if(NOT X64)
        set(A_SRCS ${A_SRCS} pixel-32.asm)
    endif()

    if(MSVC_IDE OR XCODE)
        # MSVC requires custom build rules in the main cmake script for nasm
        set(MSVC_ASMS "${A_SRCS}" CACHE INTERNAL "nasm sources")
        set(A_SRCS)
    endif()

    enable_language(ASM_NASM)

    foreach(SRC ${A_SRCS} ${C_SRCS})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} x86/${SRC})
    endforeach()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND X86)

if(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))
    if(ARM64)
        if(GCC AND (CMAKE_CXX_FLAGS_RELEASE MATCHES "-O3"))
            message(STATUS "Detected CXX compiler using -O3 optimization level")
            add_definitions(-DAUTO_VECTORIZE=1)
        endif()
        set(C_SRCS asm-primitives.cpp pixel.h ipfilter8.h)

        # add ARM assembly/intrinsic files here
        set(A_SRCS asm.S mc-a.S sad-a.S pixel-util.S ipfilter8.S)
        set(VEC_PRIMITIVES)

        set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
        foreach(SRC ${C_SRCS})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
        endforeach()
    else()
        set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h)

        # add ARM assembly/intrinsic files here
        set(A_SRCS asm.S cpu-a.S mc-a.S sad-a.S pixel-util.S ssd-a.S blockcopy8.S ipfilter8.S dct-a.S)
        set(VEC_PRIMITIVES)

        set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
        foreach(SRC ${C_SRCS})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} arm/${SRC})
        endforeach()
    endif()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))

if(POWER)
    set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS -DX265_VERSION=${X265_VERSION})
    if(ENABLE_ALTIVEC)
        set(ALTIVEC_SRCS pixel_altivec.cpp dct_altivec.cpp ipfilter_altivec.cpp intrapred_altivec.cpp)
        foreach(SRC ${ALTIVEC_SRCS})
            set(ALTIVEC_PRIMITIVES ${ALTIVEC_PRIMITIVES} ppc/${SRC})
        endforeach()
        source_group(Intrinsics_altivec FILES ${ALTIVEC_PRIMITIVES})
        set_source_files_properties(${ALTIVEC_PRIMITIVES} PROPERTIES COMPILE_FLAGS "-Wno-unused  -Wno-unknown-pragmas -Wno-maybe-uninitialized")
    endif()
endif()


# set_target_properties can't do list expansion
string(REPLACE ";" " " VERSION_FLAGS "${VFLAGS}")
set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS ${VERSION_FLAGS})

check_symbol_exists(strtok_r "string.h" HAVE_STRTOK_R)
if(HAVE_STRTOK_R)
    set_source_files_properties(param.cpp PROPERTIES COMPILE_FLAGS -DHAVE_STRTOK_R=1)
endif()

if(GCC AND CC_HAS_NO_NARROWING)
    set_source_files_properties(cpu.cpp PROPERTIES COMPILE_FLAGS -Wno-narrowing)
endif()
if(WIN32)
    set(WINXP winxp.h winxp.cpp)
endif(WIN32)

add_library(common OBJECT
    ${ASM_PRIMITIVES} ${VEC_PRIMITIVES} ${ALTIVEC_PRIMITIVES} ${WINXP}
    primitives.cpp primitives.h
    pixel.cpp dct.cpp lowpassdct.cpp ipfilter.cpp intrapred.cpp loopfilter.cpp
    constants.cpp constants.h
    cpu.cpp cpu.h version.cpp
    threading.cpp threading.h
    threadpool.cpp threadpool.h
    wavefront.h wavefront.cpp
    md5.cpp md5.h
    bitstream.h bitstream.cpp
    yuv.cpp yuv.h
    shortyuv.cpp shortyuv.h
    picyuv.cpp picyuv.h
    common.cpp common.h
    param.cpp param.h
    frame.cpp frame.h
    framedata.cpp framedata.h
    cudata.cpp cudata.h
    slice.cpp slice.h
    lowres.cpp lowres.h mv.h 
    piclist.cpp piclist.h
    predict.cpp  predict.h
    scalinglist.cpp scalinglist.h
    quant.cpp quant.h contexts.h
    deblock.cpp deblock.h
    scaler.cpp scaler.h)

=== debian/changelog ===
x265 (3.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 24 Sep 2021 00:47:21 +0200

x265 (3.5-1) experimental; urgency=medium

  * New upstream release
  * SONAME bump: 192 -> 199
  * debian/control: Bump Standards-Version
  * debian/copyright: Bump copyright years
  * debian/patches: Remove unsused dlopen code path

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 22 Aug 2021 22:18:25 +0200

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,12 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
+ git,
  libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
  nasm (>= 2.13) [amd64 kfreebsd-amd64]
 Build-Depends-Indep:
  python3-sphinx
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: http://x265.org
 Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
@@ -43,7 +44,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-192 (= ${binary:Version})
+ libx265-199 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +54,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-192
+Package: libx265-199
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,8 @@
 export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)
 
 FLAGS  = -DENABLE_PIC=ON
-# currently fails to build
-# FLAGS += -DENABLE_DYNAMIC_HDR10=ON
+# no shared libs are built if HDR10+ is enabled
+# FLAGS += -DENABLE_HDR10_PLUS=ON
 FLAGS_OTHERBIT  = -DENABLE_CLI=OFF
 FLAGS_OTHERBIT += -DENABLE_SHARED=OFF
 FLAGS_OTHERBIT += -DEXPORT_C_API=OFF

## x265 3.6

=== debian/changelog ===
x265 (3.6-3) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 08 Jun 2024 19:06:19 +0200

x265 (3.6-2) experimental; urgency=medium

  * debian/control: Set RRR: no
  * debian/:
    - Disable use of assembly on arm{el,hf}
    - Enable use of assembly on arm64

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 01 Jun 2024 10:53:39 +0200

x265 (3.6-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Sebastian Ramacher ]
  * New upstream version 3.6
  * SONAME bump: 199 -> 209
  * debian/control:
    - Update Homepage
    - Bump Standards-Version
  * debian/:
    - Build with ninja
    - Use dh-sequence-sphinxdoc instead of overrides
  * debian/rules: Use before/after overrides
  * debian/patches: Refresh patches

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 09 May 2024 19:44:35 +0200

=== debian/control ===
--- 
+++ 
@@ -8,13 +8,16 @@
  cmake,
  git,
  libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
- nasm (>= 2.13) [amd64 kfreebsd-amd64]
+ nasm [amd64],
+ ninja-build
 Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
  python3-sphinx
-Standards-Version: 4.6.0
-Homepage: http://x265.org
+Standards-Version: 4.7.0
+Homepage: https://bitbucket.org/multicoreware/x265_git
 Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
+Rules-Requires-Root: no
 
 Package: x265
 Architecture: any
@@ -44,7 +47,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-199 (= ${binary:Version})
+ libx265-209 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -54,7 +57,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-199
+Package: libx265-209
 Section: libs
 Architecture: any
 Multi-Arch: same
